## Cat'o'Cloud
Описания пока нет :(

Порт `8080`
Участникам выдать `main.py` и IP-адрес.

## Writeup
Заходя на главную страницу сервиса, обнаруживаем возможность загружать файлы. Загрузив пробный файл, обнаруживаем, что каждому файлу в хранилище присваивается идентификатор из трех латинских букв. На странице доступны опции Download (Загрузить) и Share (Поделиться), однако загрузка файла невозможна, так как ссылается на испорченное значение поля Filename. 

![file](screenshots/file.png)

Анализируя `main.py`, обнаруживаем, что файлы сохраняются в папке `storage` (и доступны по этому адресу). К тому же, перед возвратом страницы файла (или переадресации на главную страницу с задержкой) выполняется запрос на эндпоинт `/check_file`. Попытки обратиться к нему напрямую успехом не увенчиваются – становится понятно, что эндпоинт доступен только во внутренней сети.

![403](screenshots/403.png)

Осталось найти в сервисе SSRF. В исходном коде HTML меню Share обнаруживается отправка POST-запроса на `/validate_query` с передачей некоторого URL (по умолчанию различных соцсетей, но содержимое поля может быть изменено пользователем). 

![share_source](screenshots/share_source.png)

Попробуем отправить запрос на полученный адрес загруженного нами файла – и убедимся, что таким способом действительно можно обнаруживать полные имена файлов на сервере:

![test_request](screenshots/test_request.png)

Дальнейшую атаку с перебором идентификаторов можно организовать, например, с помощью расширения Turbo Intruder:

![turbo_intruder_setup](screenshots/turbo_intruder_setup.png)

![turbo_intruder_finished](screenshots/turbo_intruder_finished.png)

И, наконец, получив имя файла, забираем флаг по адресу `/storage/qtk_flag_98bf8ef9.txt`:

![flag](screenshots/flag.png)

## Flag
MCTF{Et_7u_Bru73?}

## Complexity
Medium
